Redmine - Patch #19116

Files REST API
2015-02-16 20:23 - Lucile Quirion

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: REST API Estimated time: 0.00 hour
Target version: 3.4.0

Description

Context:

To integrate Redmine with our ClI tool (Jenkins), | need to be able to upload files via the REST API.

This patch add the Files REST API for:
- getting the list of files for a project and its versions.
- creating new files from uploaded attachments.

Apply on svn revision r14015
Formatted with git
Related Issues: #7725, #18245 and #13800

Related issues:

Related to Redmine - Feature #7725: REST API for files Closed 2011-02-25
Related to Redmine - Feature #18245: Documents REST API New
Related to Redmine - Feature #13800: File REST API New

Associated revisions

Revision 16109 - 2016-12-21 11:05 - Jean-Philippe Lang
Files REST API (#19116).

Patch by Lucile Quirion and Jake Kemme.

History

#1 - 2015-02-16 20:56 - Lucile Quirion
- Category set to REST API

#2 - 2015-02-16 22:35 - Lucile Quirion
- Description updated

- Status changed from New to Needs feedback

#3 - 2015-02-18 13:06 - Jean-Philippe Lang
- Assignee set to Lucile Quirion
That's a good start but here are a few things that need to be changed:

o |'ll prefer to keep only one resource for project files, which would be /projects/:project_id/files, so we should remove the alternate POST
/projects/foo/versions/123/files to create a file associated to a version (POST /projects/foo/files with a version_id attribute will be used instead).

e POST /projects/:project_id/files should create a single file with the file attributes given in a "file" hash (instead of attachments / file_1), eg.

{ "file": {
"filename": "foo",

e GET /projects/:project_id/files should include the names of author and version (if any), just like it's done for the issues, eg.:

api.author(:id => file.author_id, :name => file.author.name)
https://www.redmine.org/projects/redmine/repository/svn/revisions/14015
https://www.redmine.org/issues/7725
https://www.redmine.org/issues/18245
https://www.redmine.org/issues/13800

e Maybe should simply use the AttachmentsHelper#render_api_attachment to format most of the file attributes

¢ We don't keep track of authors in the source code

e | hold the copyright for the Redmine source code, | can't include a source file that is copyrighted to a third-party in the core.

#4 - 2015-02-18 18:01 - Lucile Quirion
Thanks for the feedback, I'll modify my patch.

Concerning the POST request, would the following JSON be acceptable ?

{ "project": {
"version_id": "123",
"files": [

{ "filename": "file_1",
"description": "",
"content_type": "",
"token": "foo_1"

by

{ "filename": "file_2",
"token": "foo_2"

}

Where version_id, filename, description and content_type are optional parameters.

This way it will be possible to handle several files at once (as done in the IssuesController).

#5 - 2015-02-19 17:15 - Lucile Quirion
- File 0001-REST-API-add-files-REST-API_v2.patch added

Here is the updated patch.
The expected JSON format is

{ "file": {
"filename",

}

| used the AttachmentsHelper#render_api_attachment, which I've modified to accept additional options (in order to diplay the version_id).

| can remove this modification if necessary.

#6 - 2015-02-23 15:22 - Lucile Quirion

- Assignee changed from Lucile Quirion to Jean-Philippe Lang

#7 - 2015-03-18 08:57 - Toshi MARUYAMA
- Related to Feature #7725: REST API for files added

#8 - 2015-03-18 08:57 - Toshi MARUYAMA
- Related to Feature #18245: Documents REST APl added

#9 - 2015-03-18 08:58 - Toshi MARUYAMA
- Related to Feature #13800: File REST API added

#10 - 2015-10-05 11:11 - Marco Descher

Any chance this will be part of an upcoming release? :)

#11 - 2016-01-07 17:06 - Larry Owen

What's the status on this feature? Sure would be helpful.

#12 - 2016-01-09 05:01 - Go MAEDA
The patch 0001-REST-API-add-files-REST-API_v2.patch cannot be applied to current trunk (r15012).

$ patch -pl < 0001-REST-API-add-files-REST-API_v2.patch
patching file app/controllers/files_controller.rb
Hunk #3 FAILED at 49.

1 out of 3 hunks FAILED -- saving rejects to file app/controllers/files_controller.rb.rej

patching file app/helpers/attachments_helper.rb

patching file app/views/files/index.api.rsb

patching file test/integration/api_test/api_routing_test.rb
patching file test/integration/api_test/files_test.rb

#13 - 2016-07-22 19:08 - Jake Kemme
- File 0001-REST-API-add-files-REST-API_v3.patch added

Updated Patch from Hg attached. We are currently using on 3.3 with no issues.

#14 - 2016-08-21 06:31 - Toshi MARUYAMA
- Status changed from Needs feedback to New

- Target version set to 3.4.0

#15 - 2016-12-21 11:06 - Jean-Philippe Lang

- Status changed from New to Closed

Committed in r16109 with a few changes to the index response. Thanks.

Files

0001-REST-API-add-files-REST-API.patch 9.41 KB 2015-02-16 Lucile Quirion

0001-REST-API-add-files-REST-API_v2.patch 9.43 KB 2015-02-19 Lucile Quirion

0001-REST-API-add-files-REST-API_v3.patch 8.48 KB 2016-07-22 Jake Kemme
2025-07-15 3/3


https://www.redmine.org/projects/redmine/repository/svn/revisions/15012
https://www.redmine.org/projects/redmine/repository/svn/revisions/16109
http://www.tcpdf.org

